"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var abnf_1 = require("./impl/abnf");
var antlr4_1 = require("./impl/antlr4");
var cppAntlr_1 = require("./impl/cppAntlr");
var golang_1 = require("./impl/golang");
var scss_1 = require("./impl/scss");
var sexpression_1 = require("./impl/sexpression");
var smalltalk_1 = require("./impl/smalltalk");
var julia_1 = require("./impl/julia");
function getParserImpl(language) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (language === 'c') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/c/CLexer').CLexer,
                        Parser: require('./grammar/c/CParser').CParser,
                        mainRule: 'compilationUnit',
                        redundantTypes: function (node) { return node.children.length === 1 && node.type.endsWith('Expression'); }
                    }];
            }
            else if (language === 'rust') {
                return [2 /*return*/, {
                        treeSitterParser: 'tree-sitter-rust.wasm'
                    }];
            }
            else if (language === 'cpp') {
                return [2 /*return*/, {
                        treeSitterParser: 'tree-sitter-cpp.wasm'
                    }];
            }
            else if (language === 'bash') {
                return [2 /*return*/, {
                        treeSitterParser: 'tree-sitter-bash.wasm',
                        redundantTypes: function (node, parent) { return preventRedundantTypeNames(node, parent, function (node, parent) { return [' '].includes(node.type); }); }
                    }];
            }
            else if (language === 'scala') {
                return [2 /*return*/, {
                        treeSitterParser: 'tree-sitter-scala.wasm'
                    }];
            }
            // else if (language === 'ocaml') {
            // }
            else if (language === 'julia') {
                return [2 /*return*/, julia_1.getJuliaImpl()];
            }
            else if (language === 'cppAntlr') {
                return [2 /*return*/, cppAntlr_1.getCppImpl()];
            }
            else if (language === 'antlr4') {
                return [2 /*return*/, antlr4_1.getAntlr4Impl()];
            }
            else if (language === 'golang') {
                return [2 /*return*/, golang_1.getGolangImpl()];
            }
            else if (language === 'ruby') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/ruby/RubyLexer').RubyLexer,
                        Parser: require('./grammar/ruby/RubyParser').RubyParser,
                        mainRule: 'prog'
                    }];
            }
            else if (language === 'java9') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/java9/Java9Lexer').Java9Lexer,
                        Parser: require('./grammar/java9/Java9Parser').Java9Parser,
                        mainRule: 'compilationUnit',
                        redundantTypes: function (node, parent) { return [
                            'primaryNoNewArray_lfno_primary', 'assignmentExpression', 'conditionalExpression', 'conditionalOrExpression', 'conditionalAndExpression', 'inclusiveOrExpression', 'exclusiveOrExpression', 'andExpression', 'equalityExpression', 'relationalExpression', 'shiftExpression', 'additiveExpression', 'multiplicativeExpression', 'unaryExpression', 'unaryExpressionNotPlusMinus', 'unannClassType_lfno_unannClassOrInterfaceType',
                        ].includes(node.type)
                            && (node.children.length === 1 ? node.children[0].text === node.text : node.children.length === 0) && !(!!parent && parent.text !== node.text); }
                    }];
            }
            else if (language === 'lua') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/lua/LuaLexer').LuaLexer,
                        Parser: require('./grammar/lua/LuaParser').LuaParser,
                        mainRule: 'chunk'
                    }];
            }
            else if (language === 'sexpression') {
                return [2 /*return*/, sexpression_1.getSExpressionImpl()];
            }
            else if (language === 'abnf') {
                return [2 /*return*/, abnf_1.getAbnfImpl()];
            }
            else if (language === 'scss') {
                return [2 /*return*/, scss_1.getScssImpl()];
            }
            else if (language === 'dart2') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/dart2/Dart2Lexer').Dart2Lexer,
                        Parser: require('./grammar/dart2/Dart2Parser').Dart2Parser,
                        mainRule: 'compilationUnit',
                        redundantTypes: function (node) { return node.children.length === 1 && node.type.endsWith('Expression'); }
                    }];
            }
            else if (language === 'python3') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/python3/Python3Lexer').Python3Lexer,
                        Parser: require('./grammar/python3/Python3Parser').Python3Parser,
                        mainRule: 'file_input',
                        redundantTypes: function (node, parent) { return (node.type.endsWith('expr') || node.type.endsWith('test')
                            || ['term', 'factor', 'power', 'small_stmt', 'simple_stmt', 'compound_stmt', 'suite', 'number'].includes(node.type))
                            && (node.children.length === 1 ? (node.children[0].text === node.text) : node.children.length === 0) && !(!!parent && parent.text !== node.text); }
                    }];
            }
            else if (language === 'erlang') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/erlang/ErlangLexer').ErlangLexer,
                        Parser: require('./grammar/erlang/ErlangParser').ErlangParser,
                        mainRule: 'forms',
                        redundantTypes: function (node, parent) { return preventRedundantTypeNames(node, parent, function (node, parent) { return !!node.type.match(/expr[0-9]+/) || ['exprMax', 'expr'].includes(node.type); }); }
                    }];
            }
            else if (language === 'java') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/java/JavaLexer').JavaLexer,
                        Parser: require('./grammar/java/JavaParser').JavaParser,
                        mainRule: 'compilationUnit'
                    }];
            }
            else if (language === 'kotlin') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/kotlin/KotlinLexer').KotlinLexer,
                        Parser: require('./grammar/kotlin/KotlinParser').KotlinParser,
                        mainRule: 'kotlinFile',
                        redundantTypes: function (node, parent) { return preventRedundantTypeNames(node, parent, function (node, parent) { return ['disjunction', 'conjunction', 'conditionalExpression', 'equalityComparison', 'comparison', 'namedInfix', 'elvisExpression', 'infixFunctionCall', 'rangeExpression', 'additiveExpression', 'multiplicativeExpression', 'typeRHS', 'prefixUnaryExpression', 'postfixUnaryExpression'].includes(node.type); }); }
                    }];
            }
            else if (language === 'r') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/r/RLexer').RLexer,
                        Parser: require('./grammar/r/RParser').RParser,
                        Filter: require('./grammar/r/RFilter').RFilter,
                        mainRule: 'prog'
                    }];
            }
            else if (language === 'fortran77') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/fortran77/Fortran77Lexer').Fortran77Lexer,
                        Parser: require('./grammar/fortran77/Fortran77Parser').Fortran77Parser,
                        mainRule: 'program',
                        redundantTypes: function (node, parent) { return preventRedundantTypeNames(node, parent, function (node, parent) { return node.type.startsWith('lexpr') || node.type.startsWith('aexpr'); }); }
                    }];
            }
            else if (language === 'smalltalk') {
                return [2 /*return*/, smalltalk_1.getSmalltalkImpl()];
            }
            else if (language === 'visualbasic6') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/visualbasic6/VisualBasic6Lexer').VisualBasic6Lexer,
                        Parser: require('./grammar/visualbasic6/VisualBasic6Parser').VisualBasic6Parser,
                        mainRule: 'startRule'
                    }];
            }
            else if (language === 'less') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/less/LessLexer').LessLexer,
                        Parser: require('./grammar/less/LessParser').LessParser,
                        mainRule: 'stylesheet'
                    }];
            }
            else if (language === 'wat') {
                return [2 /*return*/, {
                        Lexer: require('./grammar/wat/WatLexer').WatLexer,
                        Parser: require('./grammar/wat/WatParser').WatParser,
                        mainRule: 'module'
                    }];
            }
            else {
                throw new Error('Language unknown: ' + language);
            }
            return [2 /*return*/];
        });
    });
}
exports.getParserImpl = getParserImpl;
function preventRedundantTypeNames(node, parent, predicate) {
    var textSameAsParent = parent && parent.text === node.text;
    var textSameAsChild = node.children.length === 1 && node.children[0].text === node.text;
    return predicate(node, parent) && node.children.length < 2 && (textSameAsParent || textSameAsChild);
}
exports.preventRedundantTypeNames = preventRedundantTypeNames;
//# sourceMappingURL=parserImpl.js.map